<nz-spin nzTip="{{ 'Common.Loading' | translate }}" [nzSpinning]="isLoading">
  <nz-card nzTitle='{{ "Entity.Components.Managment" | translate }}' [nzExtra]="managersExtraTpl" nzSize="small">
    <ng-template #managersExtraTpl>
      <span (click)="editPermissionsModalVisible = true" nz-tooltip
        nzTooltipTitle='{{ "Entity.Components.Permissions" | translate }}'>
        <i class="fas fa-cogs"></i>
      </span>
    </ng-template>

    <span *ngFor="let role of roles">
      <span *ngIf="role.citizen.length > 0">
        <h4>{{"Entity.Components." + role.role | translate }}</h4>
        <h5 *ngFor="let citizen of role.citizen.slice(0, 10)">
          <nz-avatar [nzShape]="'square'" [nzSize]="30" [nzIcon]="'user'" [nzSrc]="citizen.avatar">
          </nz-avatar>
          <a style="margin-left: 5px" [routerLink]="['/citizen', citizen.id]">{{ citizen.name }}</a>
        </h5>
        <div class="text-link">
          <a *ngIf="role.citizen.length > 10" (click)="showAllMembers(role)">{{ 'Common.seeMore' | translate }}</a>
        </div>
      </span>
    </span>
  </nz-card>
</nz-spin>

<nz-modal [(nzVisible)]="allMembersModalVisible" nzTitle="{{ 'Common.allMembers' | translate }}" [nzFooter]="null"
  nzWidth="30%" (nzOnCancel)="allMembersModalVisible = false" nzMaskClosable="false">
  <ng-container *nzModalContent>
    <nz-spin nzTip="{{ 'Common.Loading' | translate }}" [nzSpinning]="isLoading">
      <div *ngIf="selectedRole">
        <h4>{{ selectedRole.role }}</h4>
        <h5 *ngFor="let citizen of paginatedCitizens">
          <nz-avatar [nzShape]="'square'" [nzSize]="30" [nzIcon]="'user'" [nzSrc]="citizen.avatar">
          </nz-avatar>
          <a style="margin-left: 5px" [routerLink]="['/citizen', citizen.id]">{{ citizen.name }}</a>
        </h5>
      </div>
      <nz-pagination class="pagination-member" [(nzPageIndex)]="currentPageCitizens" [nzTotal]="totalMembers"
        [nzPageSize]="pageSize" [nzSize]="'small'" (nzPageIndexChange)="onPageChangeCitizens($event)">
      </nz-pagination>
    </nz-spin>
  </ng-container>
</nz-modal>

<nz-modal [(nzVisible)]="editPermissionsModalVisible"
  nzTitle='{{ "Entity.Components.permissionsManagment" | translate }}' [nzFooter]="null" nzWidth="70%"
  (nzOnCancel)="editPermissionsModalVisible = false" nzMaskClosable="false">
  <ng-container *nzModalContent>
    <nz-spin nzTip="{{ 'Common.Loading' | translate }}" [nzSpinning]="isLoading">
      <div nz-row nzGutter="12">
        <div nz-col nzSpan="10">
          <nz-list nzBordered nzSize="small">
            <nz-list-header>{{ "Entity.Components.Managers" | translate }}</nz-list-header>
            <nz-list-item *ngFor="let citizen of paginatedManagers" (click)="selectManager(citizen)">
              <nz-avatar [nzShape]="'square'" [nzSize]="30" [nzIcon]="'user'" [nzSrc]="citizen.avatar">
              </nz-avatar>
              <span style="margin-left: 5px">{{ citizen.name }}</span>
            </nz-list-item>
            <nz-pagination class="pagination-member" [(nzPageIndex)]="currentPageManagers" [nzTotal]="totalManagers"
            [nzPageSize]="pageSize" [nzSize]="'small'" (nzPageIndexChange)="onPageChangeManagers($event)">
          </nz-pagination>
            <nz-list-footer>
              <div nz-row>
                <div nz-col nzSpan="20">
                  <nz-select nzPlaceHolder='{{ "Entity.Components.selectCitizen" | translate }}' style="width: 100%"
                    nzSize="small" nzAllowClear nzShowSearch nzServerSearch [(ngModel)]="newManagerId"
                    (nzOnSearch)="searchCitizen($event)">
                    <ng-container *ngFor="let o of citizens">
                      <nz-option *ngIf="!isLoading" [nzValue]="o.id" [nzLabel]="o.name"></nz-option>
                    </ng-container>
                    <nz-option *ngIf="isLoading" nzDisabled nzCustomContent>
                      <i nz-icon nzType="loading" class="loading-icon"></i>
                      {{ 'Common.Loading' | translate }}
                    </nz-option>
                  </nz-select>
                </div>
                <div nz-col nzSpan="4">
                  <button style="width: 100%" nzSize="small" nz-button nzShape="round" nzType="primary"
                    (click)="addNewManager()">
                    {{ "Common.Add" | translate }}
                  </button>
                </div>
              </div>
            </nz-list-footer>
          </nz-list>
      
        </div>

        <div nz-col nzSpan="14">
          <div *ngIf="currentUserPermissions != undefined">
            <div nz-row style="margin-top: 5px">
              <div nz-col nzSpan="16">
                <h3>{{ currentUserPermissions.name }}</h3>
              </div>
              <div nz-col nzSpan="8">
                <button nzSize="small" nz-button nzShape="round" nzType="primary"
                  (click)="updatePermissions(currentUserPermissions)">
                  {{ "Common.Update" | translate }}
                </button>
                <button style="background-color: red; border-color: darkred" nzSize="small" nzShape="round" nz-button
                  nzType="primary" (click)="removeManager(currentUserPermissions.id)">
                  {{ "Common.Remove" | translate }}
                </button>
              </div>
            </div>

            <nz-tabset>
              <nz-tab [nzTitle]="permissionsTitle">
                <ng-template #permissionsTitle>
                  {{ "Entity.Components.Permissions" | translate }}
                </ng-template>
                <div>
                  <label nz-checkbox [(ngModel)]="currentUserPermissions.permissions.isOwner">{{
                    "Social.Community.Owner" | translate }}</label>
                </div>
                <hr />
                <h4>{{ "Entity.Components.ManageCompanies" | translate }}</h4>
                <div *ngFor="let item of companies">
                  <label nz-checkbox [(ngModel)]="item.isManaging">{{ item.name }}</label>
                </div>
                <div *ngIf="currentUserPermissions.permissions && currentUserPermissions.permissions.newspaper">
                  <hr />
                  <div>
                    <label nz-checkbox [(ngModel)]="currentUserPermissions.permissions.newspaper.isEditor">{{
                      "Entity.Components.NewspaperEditor" | translate }}</label>
                  </div>
                </div>
              </nz-tab>
              <nz-tab [nzTitle]="logsTitle" [nzDisabled]="true">
                <ng-template #logsTitle>{{ "Entity.Components.auditLogsComing" | translate }}</ng-template>
                {{ "Social.Community.Logs" | translate }}
              </nz-tab>
            </nz-tabset>
          </div>
        </div>
      </div>
    </nz-spin>
  </ng-container>
</nz-modal>